SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest class methodsFor: 'cart' stamp: 'GrossodelSel 6/15/2012 16:38'!
newNonEmptyCart

	^ self newEmptyCart add: self bookIsbn1 quantity: 3.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 6/13/2012 16:15'!
aBookIsbnOutOfEditorial

	^ 'this book isbn is not in the Editorial'.! !

!TusLibrosTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/13/2012 16:32'!
bookIsbn1
	
	^ 'bookIsbn1'.! !

!TusLibrosTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/13/2012 16:48'!
bookIsbn2
	
	^ 'bookIsbn2'.! !

!TusLibrosTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/13/2012 16:48'!
bookIsbn3
	
	^ 'bookIsbn3'.! !

!TusLibrosTest methodsFor: 'editorial-books' stamp: 'GrossodelSel 6/13/2012 16:48'!
bookIsbnsOfEditorial

	^ Set with: self bookIsbn1 with: self bookIsbn2 with: self bookIsbn3.! !

!TusLibrosTest methodsFor: 'error' stamp: 'GrossodelSel 6/15/2012 16:18'!
canNotAddAnInvalidQuantityOfBookIsbnsErrorMessage

	^ 'the specified quantity must be greater than zero'.! !

!TusLibrosTest methodsFor: 'error' stamp: 'GrossodelSel 6/15/2012 16:18'!
canNotAddToCartABookIsbnThatIsNotFromTheEditorialErrorMessage
	
	^ 'the specified book isbn must belong to the editorial'.! !

!TusLibrosTest methodsFor: 'cart' stamp: 'GrossodelSel 6/15/2012 16:38'!
newCartWithOneCopyOfEachBookIsbn

	| cart |
	cart := self newEmptyCart.
	
	self bookIsbnsOfEditorial do:
		[ :aBookIsbn | cart add: aBookIsbn quantity: 1 ].
	
	^ cart.! !

!TusLibrosTest methodsFor: 'cart' stamp: 'GrossodelSel 6/15/2012 16:38'!
newEmptyCart

	^ Cart withEditorialBookIsbns: self bookIsbnsOfEditorial.! !

!TusLibrosTest methodsFor: 'test-cart' stamp: 'GrossodelSel 6/15/2012 16:38'!
test01CartShouldBeEmptyAfterCreation

	self assert: self newEmptyCart isEmpty.! !

!TusLibrosTest methodsFor: 'test-cart' stamp: 'GrossodelSel 6/15/2012 16:38'!
test02CartShouldNotBeEmptyAfterAddingABookIsbnOfTheEditorial
	
	| cart |
	cart := self newEmptyCart.
	
	cart add: (self bookIsbn1) quantity: 1.
	
	self deny: cart isEmpty.! !

!TusLibrosTest methodsFor: 'test-cart' stamp: 'GrossodelSel 6/15/2012 17:02'!
test03CartsCanBeComparedWithEquals

	self assert: self newEmptyCart = self newEmptyCart.
	self assert: self newCartWithOneCopyOfEachBookIsbn = self newCartWithOneCopyOfEachBookIsbn.
	
	self deny: self newEmptyCart = self newCartWithOneCopyOfEachBookIsbn.
	self deny: self newCartWithOneCopyOfEachBookIsbn = self newEmptyCart.! !

!TusLibrosTest methodsFor: 'test-cart' stamp: 'GrossodelSel 6/15/2012 16:55'!
test04CanNotAddAnInvalidQuantityOfBookIsbnsToCart
	
	| anEmptyCart aNonEmptyCart |
	
	"Emtpy cart test"
	anEmptyCart := self newEmptyCart.
	self should: [ anEmptyCart add: self bookIsbn2 quantity: -1 ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: (anError messageText = self canNotAddAnInvalidQuantityOfBookIsbnsErrorMessage).
			self assert: (anEmptyCart = self newEmptyCart) ].
	
	
	"Non empty cart test"
	aNonEmptyCart := self newCartWithOneCopyOfEachBookIsbn.
	
	self should: [ aNonEmptyCart add: self bookIsbn2 quantity: -1 ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: (anError messageText = self canNotAddAnInvalidQuantityOfBookIsbnsErrorMessage).
			self assert: aNonEmptyCart = self newCartWithOneCopyOfEachBookIsbn ].
! !

!TusLibrosTest methodsFor: 'test-cart' stamp: 'GrossodelSel 6/15/2012 16:55'!
test05CanNotAddToCartABookIsbnThatIsNotFromTheEditorial
	
	| anEmptyCart aNonEmptyCart |
	
	"Emtpy cart test"
	anEmptyCart := self newEmptyCart.
	self should: [ anEmptyCart add: (self aBookIsbnOutOfEditorial) quantity: 1 ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: (anError messageText = self canNotAddToCartABookIsbnThatIsNotFromTheEditorialErrorMessage).
			self assert: (anEmptyCart = self newEmptyCart) ].
	
	
	"Non empty cart test"
	aNonEmptyCart := self newCartWithOneCopyOfEachBookIsbn.
	
	self should: [ aNonEmptyCart add: (self aBookIsbnOutOfEditorial) quantity: 1 ]
		raise: Error
		withExceptionDo: [ : anError |
			self assert: (anError messageText = self canNotAddToCartABookIsbnThatIsNotFromTheEditorialErrorMessage).
			self assert: (aNonEmptyCart = self newCartWithOneCopyOfEachBookIsbn) ].
! !

!TusLibrosTest methodsFor: 'test-cart' stamp: 'GrossodelSel 6/15/2012 16:55'!
test06CartShouldContainTheSameAmountOfAGivenBookIsbnThatWasAdded
	
	| cart |
	cart := self newEmptyCart.
	
	cart add: self bookIsbn1 quantity: 2.
	self assert: (cart quantityOf: self bookIsbn1) = 2.
	
	cart add: self bookIsbn1 quantity: 3.
	self assert: (cart quantityOf: self bookIsbn1) = 5.
	
	self assert: (cart quantityOf: self bookIsbn2) = 0.! !

!TusLibrosTest methodsFor: 'test-cart' stamp: 'GrossodelSel 6/15/2012 16:55'!
test07CartCanBeEnumeratedUsingDo

	| initialSetOfBookIsbns enumeratedSetOfBookIsbns |
	
	initialSetOfBookIsbns := self bookIsbnsOfEditorial.
	enumeratedSetOfBookIsbns := Set new.
	
	(self newCartWithOneCopyOfEachBookIsbn) do: [ :aBookIsbn |
		enumeratedSetOfBookIsbns add: aBookIsbn ].
	
	self assert: initialSetOfBookIsbns = enumeratedSetOfBookIsbns.
! !

Object subclass: #Cart
	instanceVariableNames: 'bookIsbns editorialBookIsbns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'GrossodelSel 6/13/2012 16:19'!
withEditorialBookIsbns: aSetOfBookIsbns

	^ Cart new initializeWithEditorialBookIsbns: aSetOfBookIsbns.! !

!Cart methodsFor: 'comparing' stamp: 'GrossodelSel 6/15/2012 16:44'!
= anotherObject

	(self class = anotherObject class) ifFalse: [ ^ false ].
	
	^ (bookIsbns = anotherObject bookIsbns) and: [ editorialBookIsbns = anotherObject editorialBookIsbns ].! !

!Cart methodsFor: 'adding' stamp: 'GrossodelSel 6/13/2012 16:29'!
add: aBookIsbn quantity: aQuantity

	(aQuantity <= 0) ifTrue:
		[ self error: self invalidQuantityErrorMessage ].
	
	(editorialBookIsbns includes: aBookIsbn) ifFalse:
		[ self error: self invalidBookIsbnErrorMessage ].
	
	bookIsbns add: aBookIsbn withOccurrences: aQuantity.! !

!Cart methodsFor: 'accessing' stamp: 'GrossodelSel 6/15/2012 16:43'!
bookIsbns
	^ bookIsbns! !

!Cart methodsFor: 'enumerating' stamp: 'GrossodelSel 6/13/2012 17:10'!
do: aBlock

	bookIsbns valuesAndCounts keysDo: aBlock.! !

!Cart methodsFor: 'accessing' stamp: 'GrossodelSel 6/15/2012 16:43'!
editorialBookIsbns
	^ editorialBookIsbns! !

!Cart methodsFor: 'initializing' stamp: 'GrossodelSel 6/13/2012 16:17'!
initializeWithEditorialBookIsbns: aSetOfBookIsbns

	bookIsbns := Bag new.
	editorialBookIsbns := aSetOfBookIsbns.! !

!Cart methodsFor: 'error' stamp: 'GrossodelSel 6/15/2012 16:18'!
invalidBookIsbnErrorMessage

	^ 'the specified book isbn must belong to the editorial'.! !

!Cart methodsFor: 'error' stamp: 'GrossodelSel 6/13/2012 16:04'!
invalidQuantityErrorMessage

	^ 'the specified quantity must be greater than zero'.! !

!Cart methodsFor: 'testing' stamp: 'GrossodelSel 6/13/2012 15:43'!
isEmpty

	^ bookIsbns isEmpty.! !

!Cart methodsFor: 'accessing' stamp: 'GrossodelSel 6/13/2012 16:53'!
quantityOf: aBookIsbn 

	^ bookIsbns occurrencesOf: aBookIsbn.! !
